## projectm 2.1.0+dfsg

=== CMakeLists.txt ===
PROJECT(projectM-complete)
cmake_minimum_required(VERSION 2.8.0)

include(src/cmake/CPack-projectM.cmake)

add_subdirectory(src)

=== fonts/CMakeLists.txt ===
PROJECT(fonts)
cmake_minimum_required(VERSION 2.4.0)
cmake_policy(SET CMP0005 OLD)

if(COMMAND cmake_policy)
       cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)


Include(../src/cmake/CPack-projectM.cmake)

=== presets/CMakeLists.txt ===
PROJECT(presets)
cmake_minimum_required(VERSION 2.4.0)
cmake_policy(SET CMP0005 OLD)

if(COMMAND cmake_policy)
       cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)


Include(../src/cmake/CPack-projectM.cmake)

=== presets_milkdrop/CMakeLists.txt ===
PROJECT(presets_milkdrop)
cmake_minimum_required(VERSION 2.4.0)
cmake_policy(SET CMP0005 OLD)

if(COMMAND cmake_policy)
       cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

Include(../src/cmake/CPack-projectM.cmake)

=== presets_milkdrop_104/CMakeLists.txt ===
PROJECT(presets_milkdrop_104)
cmake_minimum_required(VERSION 2.4.0)
cmake_policy(SET CMP0005 OLD)

if(COMMAND cmake_policy)
       cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

Include(../src/cmake/CPack-projectM.cmake)

=== presets_milkdrop_200/CMakeLists.txt ===
PROJECT(presets_milkdrop_200)
cmake_minimum_required(VERSION 2.4.0)
cmake_policy(SET CMP0005 OLD)

if(COMMAND cmake_policy)
       cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

Include(../src/cmake/CPack-projectM.cmake)

=== presets_projectM/CMakeLists.txt ===
PROJECT(presets-projectm)
cmake_minimum_required(VERSION 2.4.0)
cmake_policy(SET CMP0005 OLD)

if(COMMAND cmake_policy)
       cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)


Include(../src/cmake/CPack-projectM.cmake)

=== src/CMakeLists.txt ===
project (projectM-complete)

cmake_minimum_required(VERSION 2.4.0)

OPTION(INCLUDE-PROJECTM-QT "Build the projectM Qt4 user interface extension library (recommended)" ON)
OPTION(INCLUDE-PROJECTM-PULSEAUDIO "Build the projectM pulse audio client (recommended for fedora users)" ON)
OPTION(INCLUDE-PROJECTM-LIBVISUAL "Build the projectM libvisual client" ON)
OPTION(INCLUDE-PROJECTM-LIBVISUAL-ALSA "Build experimental libvisual / alsa input standalone client (NEW!)" OFF)
OPTION(INCLUDE-PROJECTM-JACK "Build the projectM JACK client" OFF)
OPTION(INCLUDE-PROJECTM-TEST "Build the projectM test suite" ON)
OPTION(INCLUDE-PROJECTM-XMMS "Build the projectM xmms module (deprecated, use audacious instead)" OFF)
OPTION(INCLUDE-NATIVE-PRESETS "Build the projectM native preset sample collection " ON)

set(PROJECTM_ROOT_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})

add_subdirectory (libprojectM)

if(INCLUDE-PROJECTM-TEST)
	add_subdirectory (projectM-test)
endif(INCLUDE-PROJECTM-TEST)

if (INCLUDE-PROJECTM-QT)
	add_subdirectory (projectM-qt)
endif(INCLUDE-PROJECTM-QT)

if (INCLUDE-PROJECTM-JACK)
	add_subdirectory (projectM-jack)
endif (INCLUDE-PROJECTM-JACK)

if (INCLUDE-PROJECTM-PULSEAUDIO)
	add_subdirectory (projectM-pulseaudio)
endif (INCLUDE-PROJECTM-PULSEAUDIO)

if (INCLUDE-PROJECTM-XMMS)
	add_subdirectory (projectM-xmms)
endif (INCLUDE-PROJECTM-XMMS)

if (INCLUDE-PROJECTM-LIBVISUAL)
	add_subdirectory (projectM-libvisual)
endif (INCLUDE-PROJECTM-LIBVISUAL)

if (INCLUDE-PROJECTM-LIBVISUAL-ALSA)
	add_subdirectory (projectM-libvisual-alsa)
endif (INCLUDE-PROJECTM-LIBVISUAL-ALSA)

if (INCLUDE-NATIVE-PRESETS)
	add_subdirectory(NativePresets)
endif (INCLUDE-NATIVE-PRESETS)

=== src/NativePresets/CMakeLists.txt ===
project(NativePresets)
cmake_minimum_required(VERSION 2.4.0)
cmake_policy(SET CMP0005 OLD)

include(FindPkgConfig.cmake)

Include(cmake/CPack-projectM.cmake)

if (${CMAKE_PROJECT_NAME} MATCHES "projectM-complete")
	set(LIBPROJECTM_FOUND true)
else(${CMAKE_PROJECT_NAME} MATCHES "projectM-complete")
	pkg_search_module(LIBPROJECTM REQUIRED libprojectM)
endif(${CMAKE_PROJECT_NAME} MATCHES "projectM-complete")

if (LIBPROJECTM_FOUND)
	MESSAGE(STATUS "[NativePresets] projectM detected.")
else (LIBPROJECTM_FOUND)
	MESSAGE(FATAL_ERROR "projectM not detected! Please install the projectM module or build from top level projectM source directory.")
endif(LIBPROJECTM_FOUND)


ADD_DEFINITIONS(-DLINUX -DPROJECTM_PREFIX='\"${PROJECTM_PREFIX}\"')


if(COMMAND cmake_policy)
       cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)
ADD_LIBRARY(RovastarDriftingChaos SHARED RovastarDriftingChaos.cpp)
ADD_LIBRARY(RovastarDarkSecret SHARED RovastarDarkSecret.cpp)
ADD_LIBRARY(RovastarFractalSpiral SHARED RovastarFractalSpiral.cpp)
ADD_LIBRARY(RovastarFractopiaFrantic SHARED RovastarFractopiaFrantic.cpp)
ADD_LIBRARY(MstressJuppyDancer SHARED MstressJuppyDancer.cpp)

# Doesn't build yet
#ADD_LIBRARY(RLGFractalDrop7c SHARED RLGFractalDrop7c.cpp)

if (${CMAKE_PROJECT_NAME} MATCHES "projectM-complete")
   set(PROJECTM_INCLUDE ${PROJECTM_ROOT_SOURCE_DIR}/libprojectM)
   set(PROJECTM_LINK ${PROJECTM_ROOT_BINARY_DIR}/libprojectM)
elseif (${CMAKE_PROJECT_NAME} MATCHES ${PROJECT_NAME})
   set(PROJECTM_INCLUDE ${LIBPROJECTM_INCLUDEDIR}/libprojectM)
   set(PROJECTM_LINK ${PROJECTM_LDFLAGS})
endif (${CMAKE_PROJECT_NAME} MATCHES "projectM-complete")

LINK_DIRECTORIES(${PROJECTM_LINK} ${Renderer_BINARY_DIR} ${NativePresetFactory_BINARY_DIR})

include_directories(${PROJECTM_INCLUDE} ${Renderer_SOURCE_DIR} ${NativePresetFactory_SOURCE_DIR} ${CMAKE_CURRENT_LIBRARY_DIR})

target_link_libraries(RovastarDarkSecret Renderer NativePresetFactory projectM)
target_link_libraries(RovastarFractopiaFrantic Renderer NativePresetFactory projectM)
target_link_libraries(RovastarFractalSpiral Renderer NativePresetFactory projectM)
target_link_libraries(RovastarDriftingChaos Renderer NativePresetFactory projectM)
target_link_libraries(MstressJuppyDancer Renderer NativePresetFactory projectM)
# Doesn't build yet
#target_link_libraries(RLGFractalDrop7c Renderer NativePresetFactory projectM)

=== src/libprojectM/CMakeLists.txt ===
PROJECT(projectM)
cmake_minimum_required(VERSION 2.8.0)

SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "The projectM core library.")

INCLUDE(cmake/CPack-projectM.cmake)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

OPTION (USE_DEVIL "Use devIL for image loading rather than the builtin SOIL library" OFF)

OPTION (USE_FBO "Use Framebuffer Objects for increased rendering quality.  Disable this for OpenGL ES 1.x or if you are experiencing problems on older or poorly supported hardware." ON)

OPTION(USE_FTGL "Use FTGL for on-screen fonts (found on your system)" ON)

OPTION (USE_GLES1 "Use OpenGL ES 1.x" OFF)

OPTION (USE_THREADS "Use threads for parallelization" ON)

OPTION (USE_OPENMP "Use OpenMP and OMPTL for multi-core parallelization" ON)

OPTION (USE_NATIVE_GLEW "Use projectM's native implemention of GLEW." OFF)

OPTION (USE_CG "Use Cg for Pixel Shader support" OFF)

OPTION (BUILD_PROJECTM_STATIC "Build the projectM target library in the platform's native static (NOT shared) format." OFF)

OPTION (DISABLE_NATIVE_PRESETS "Turn off support for native (C++ style) presets" OFF)
OPTION (DISABLE_MILKDROP_PRESETS "Turn off support for Milkdrop (.milk / .prjm) presets"  OFF)

# projectM version block
set(PROJECTM_VERSION 2.1.0)
set(PROJECTM_ABI_LEVEL 2)
#

ADD_DEFINITIONS(-DCMAKE_INSTALL_PREFIX="\\\"${CMAKE_INSTALL_PREFIX}\\\"")

SET(LIB_INSTALL_DIR "\${exec_prefix}/lib"
  CACHE PATH "The subdirectory relative to the install prefix where libraries will be installed (default is /lib)"
  FORCE)

if (USE_NATIVE_GLEW)
ADD_DEFINITIONS(-DUSE_NATIVE_GLEW)
 SET(GLEW_SOURCES glew.h glew.c)
 SET(GLEW_LIBRARY "")
else(USE_NATIVE_GLEW)
 set (GLEW_SOURCES "")
 find_package (GLEW)
endif(USE_NATIVE_GLEW)

SET(projectM_SOURCES projectM.cpp PCM.cpp Preset.cpp fftsg.cpp KeyHandler.cpp
timer.cpp wipemalloc.cpp PresetLoader.cpp  PresetChooser.cpp PipelineMerger.cpp ConfigFile.cpp  TimeKeeper.cpp PresetFactory.cpp PresetFactoryManager.cpp ${GLEW_SOURCES})

if (MSVC)
SET(projectM_SOURCES ${projectM_SOURCES} dlfcn.c win32-dirent.cpp)
endif(MSVC)

if (NOT DISABLE_NATIVE_PRESETS)
	add_subdirectory(NativePresetFactory)
	SET(PRESET_FACTORY_SOURCES ${PRESET_FACTORY_SOURCES} ${NativePresetFactory_SOURCE_DIR})
	SET(PRESET_FACTORY_BINARY_DIR ${PRESET_FACTORY_BINARY_DIR} ${NativePresetFactory_BINARY_DIR})
	SET(PRESET_FACTORY_LINK_TARGETS ${PRESET_FACTORY_LINK_TARGETS} NativePresetFactory)
endif(NOT DISABLE_NATIVE_PRESETS)

if (NOT DISABLE_MILKDROP_PRESETS)
	add_subdirectory(MilkdropPresetFactory)
	SET(PRESET_FACTORY_SOURCES ${PRESET_FACTORY_SOURCES} ${MilkdropPresetFactory_SOURCE_DIR})
	SET(PRESET_FACTORY_BINARY_DIR ${PRESET_FACTORY_BINARY_DIR} ${MilkdropPrmaesetFactory_BINARY_DIR})
	SET(PRESET_FACTORY_LINK_TARGETS ${PRESET_FACTORY_LINK_TARGETS} MilkdropPresetFactory)
endif(NOT DISABLE_MILKDROP_PRESETS)

if (USE_DEVIL)
	SET (projectM_SOURCES ${projectM_SOURCES})
	ADD_DEFINITIONS(-DUSE_DEVIL)
	SET (IMAGE_LINK_TARGETS IL ILU ILUT)
else (USE_DEVIL)
	SET (projectM_SOURCES ${projectM_SOURCES})
	SET (IMAGE_LINK_TARGETS )
endif (USE_DEVIL)

if (USE_CG)
	ADD_DEFINITIONS(-DUSE_CG)
	SET (CG_LINK_TARGETS Cg CgGL)
else (USE_CG)
	SET (CG_LINK_TARGETS)
endif(USE_CG)

include(CheckCXXCompilerFlag)

if(USE_GLES1)
	ADD_DEFINITIONS(-DUSE_GLES1)
endif(USE_GLES1)

if(USE_FBO)
	ADD_DEFINITIONS(-DUSE_FBO)
endif(USE_FBO)

if(USE_FTGL)
	ADD_DEFINITIONS(-DUSE_FTGL)

	find_package( Freetype REQUIRED)
	include_directories( ${FREETYPE_INCLUDE_DIRS} )

endif(USE_FTGL)

if (BUILD_PROJECTM_STATIC)
	ADD_LIBRARY(projectM STATIC ${projectM_SOURCES})
else(BUILD_PROJECTM_STATIC)
	ADD_LIBRARY(projectM SHARED ${projectM_SOURCES})
endif(BUILD_PROJECTM_STATIC)

set_property(TARGET projectM PROPERTY LINK_INTERFACE_LIBRARIES "")
set_property(TARGET projectM PROPERTY IMPORTED_LINK_DEPENDENT_LIBRARIES "")
SET_TARGET_PROPERTIES(projectM PROPERTIES VERSION ${PROJECTM_VERSION} SOVERSION ${PROJECTM_ABI_LEVEL})

if (USE_THREADS)
ADD_DEFINITIONS(-DUSE_THREADS)
endif(USE_THREADS)

if (APPLE)
	ADD_DEFINITIONS(-DMACOS -DSTBI_NO_DDS)
	set(RESOURCE_PREFIX "Resources")
else (APPLE)
	if (WIN32)
		set (RESOURCE_PREFIX "Resources")
		ADD_DEFINITIONS(-DWIN32 -DSTBI_NO_DDS)
	else(WIN32)
		set (RESOURCE_PREFIX "share/projectM")
		ADD_DEFINITIONS(-DLINUX -DSTBI_NO_DDS)
	endif(WIN32)
endif(APPLE)

add_subdirectory(Renderer)

FIND_PACKAGE(OpenGL)

INCLUDE(FindPkgConfig.cmake)

pkg_search_module (FTGL ftgl)

#set(CMAKE_INCLUDE_PATH ${CMAKE_INCLUDE_PATH};/opt/local/include;/Developer/SDKs/MACOSX10.5.sdk/usr/X11/include)
#set(CMAKE_LIBRARY_PATH /opt/local/lib;/Developer/SDKs/MACOSX10.5.sdk;/Developer/SDKs/MacOSX10.5.sdk/usr/X11/lib/)

IF(USE_FTGL)
	if (FTGL_FOUND)
		MESSAGE(STATUS "[projectM] FTGL font support was detected and enabled.")
	else (FTGL_FOUND)
		MESSAGE(STATUS
	"[projectM] Warning! FTGL has been enabled but not detected. Your compilation will probably break. Turn off FTGL support by setting USE_FTGL to false, or visit http://ftgl.wiki.sourceforge.net/ for help on installing FTGL.")
	endif (FTGL_FOUND)

	ADD_DEFINITIONS(-DUSE_FTGL)

	set (FTGL_INCUDE_DIRS ${FTGL_INCLUDE_DIRS} ${CMAKE_INCLUDE_PATH} ${OPENGL_INCLUDE_DIR})
	set (FTGL_LINK_DIRS ${FTGL_LIBRARY_DIRS} )
	set (FTGL_LINK_TARGETS ftgl freetype)

ELSE (USE_FTGL)
	IF (FTGL_FOUND)
		MESSAGE(STATUS "[projectM] Warning: FTGL font support was detected but NOT enabled. You can enable it by setting USE_FTGL=true")
	ELSE (FTGL_FOUND)
		MESSAGE(STATUS "[projectM] Warning: FTGL font support was not detected. Visit http://ftgl.wiki.sourceforge.net/ for help on installing FTGL.")
	ENDIF(FTGL_FOUND)

	# todo: change this because its obscure and probably not being used
	set (FTGL_INCLUDE_DIRS "/opt/local/include")
	set (FTGL_LINK_DIRS )
	set (FTGL_LINK_TARGETS )
ENDIF(USE_FTGL)

CHECK_CXX_COMPILER_FLAG("-fopenmp" SUPPORTS_OPENMP)

IF(USE_OPENMP AND SUPPORTS_OPENMP)
	SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fopenmp ")
	SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fopenmp ")
ENDIF(USE_OPENMP AND SUPPORTS_OPENMP)

INCLUDE_DIRECTORIES(${projectM_SOURCE_DIR}
		${FTGL_INCLUDE_DIRS}
		${Renderer_SOURCE_DIR}
		${PRESET_FACTORY_SOURCES}
)
LINK_DIRECTORIES(${FTGL_LIBRARY_DIRS}
		${Renderer_BINARY_DIR}
		${PRESET_FACTORY_BINARY_DIR}
)

if(MSVC)
	SET (MATH_LIBRARIES )
else(MSVC)
	SET (MATH_LIBRARIES m)
endif(MSVC)

if(BUILD_PROJECTM_STATIC)
	TARGET_LINK_LIBRARIES(projectM Renderer
				${IMAGE_LINK_TARGETS}
				${CG_LINK_TARGETS}
				${PRESET_FACTORY_LINK_TARGETS}
				${GLEW_LIBRARY}
				${FTGL_LINK_TARGETS}
				${MATH_LIBRARIES}
				dl
				${OPENGL_LIBRARIES}
	)
else(BUILD_PROJECTM_STATIC)
	TARGET_LINK_LIBRARIES(projectM Renderer
				${IMAGE_LINK_TARGETS}
				${CG_LINK_TARGETS}
				${PRESET_FACTORY_LINK_TARGETS}
				${GLEW_LIBRARY}
				${FTGL_LINK_TARGETS}
				${MATH_LIBRARIES}
				dl
				${OPENGL_LIBRARIES}
	)
endif(BUILD_PROJECTM_STATIC)

SET(projectM_FONT_MENU "${CMAKE_INSTALL_PREFIX}/${RESOURCE_PREFIX}/fonts/VeraMono.ttf" CACHE FILEPATH "Path to the default menu TrueType font")
SET(projectM_FONT_TITLE "${CMAKE_INSTALL_PREFIX}/${RESOURCE_PREFIX}/fonts/Vera.ttf" CACHE FILEPATH "Path to the default title TrueType font")
ADD_DEFINITIONS(-DprojectM_FONT_MENU="\\\"${projectM_FONT_MENU}\\\"")
ADD_DEFINITIONS(-DprojectM_FONT_TITLE="\\\"${projectM_FONT_TITLE}\\\"")

CONFIGURE_FILE("${CMAKE_CURRENT_SOURCE_DIR}/libprojectM.pc.in" "${CMAKE_CURRENT_BINARY_DIR}/libprojectM.pc" @ONLY)
CONFIGURE_FILE("${CMAKE_CURRENT_SOURCE_DIR}/config.inp.in" "${CMAKE_CURRENT_BINARY_DIR}/config.inp" @ONLY)

IF(projectM_FONT_MENU MATCHES "${CMAKE_INSTALL_PREFIX}/${RESOURCE_PREFIX}/fonts/Vera.ttf" OR projectM_FONT_TITLE MATCHES "${CMAKE_INSTALL_PREFIX}/${RESOURCE_PREFIX}/fonts/Vera.ttf")
	INSTALL(FILES ${CMAKE_CURRENT_SOURCE_DIR}/fonts/VeraMono.ttf DESTINATION ${CMAKE_INSTALL_PREFIX}/${RESOURCE_PREFIX}/fonts)
ENDIF(projectM_FONT_MENU MATCHES "${CMAKE_INSTALL_PREFIX}/${RESOURCE_PREFIX}/fonts/Vera.ttf" OR projectM_FONT_TITLE MATCHES "${CMAKE_INSTALL_PREFIX}/${RESOURCE_PREFIX}/fonts/Vera.ttf")

IF(projectM_FONT_MENU MATCHES "${CMAKE_INSTALL_PREFIX}/${RESOURCE_PREFIX}/fonts/VeraMono.ttf" OR projectM_FONT_TITLE MATCHES "${CMAKE_INSTALL_PREFIX}/${RESOURCE_PREFIX}/fonts/VeraMono.ttf")
	INSTALL(FILES ${CMAKE_CURRENT_SOURCE_DIR}/fonts/VeraMono.ttf DESTINATION ${CMAKE_INSTALL_PREFIX}/${RESOURCE_PREFIX}/fonts)
ENDIF(projectM_FONT_MENU MATCHES "${CMAKE_INSTALL_PREFIX}/${RESOURCE_PREFIX}/fonts/VeraMono.ttf" OR projectM_FONT_TITLE MATCHES "${CMAKE_INSTALL_PREFIX}/${RESOURCE_PREFIX}/fonts/VeraMono.ttf")

FILE(GLOB presets "presets/*.milk" "presets/*.prjm" "presets/*.tga")
INSTALL(FILES ${presets} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/projectM/presets)
INSTALL(FILES ${Renderer_SOURCE_DIR}/projectM.cg ${Renderer_SOURCE_DIR}/blur.cg DESTINATION ${CMAKE_INSTALL_PREFIX}/share/projectM/shaders)
INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/libprojectM.pc DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/pkgconfig)
INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/config.inp DESTINATION ${CMAKE_INSTALL_PREFIX}/share/projectM)
INSTALL(FILES projectM.hpp event.h dlldefs.h fatal.h PCM.hpp Common.hpp DESTINATION include/libprojectM)
INSTALL(TARGETS projectM DESTINATION lib)

=== src/projectM-jack/CMakeLists.txt ===
PROJECT(projectM-jack)
cmake_minimum_required(VERSION 2.4.0)

cmake_policy(SET CMP0005 OLD)

INCLUDE(cmake/CPack-projectM.cmake)


OPTION(QT_JACK_SUPPORT "Enable Qt4 GUI Support for the projectM jack port" ON)
OPTION(BUILD_PROJECTM_JACK_STATIC "Build a binary that only depends on jack and stnadard MACOSX libraries" OFF)

if (QT_JACK_SUPPORT)

set(QT_USE_OPENGL TRUE)

include(${QT_USE_FILE} FindPkgConfig.cmake)

if (${CMAKE_PROJECT_NAME} MATCHES ${PROJECT_NAME})
	pkg_search_module(LIBPROJECTM REQUIRED libprojectM)
	pkg_search_module(LIBPROJECTM-QT REQUIRED libprojectM-qt)
	ADD_DEFINITIONS(-DLINUX -DPROJECTM_PREFIX='\"${LIBPROJECTM_PREFIX}\"')
else(${CMAKE_PROJECT_NAME} MATCHES ${PROJECT_NAME})
	set(LIBPROJECTM_FOUND true)
	set(LIBPROJECTM-QT_FOUND true)
	ADD_DEFINITIONS(-DLINUX -DPROJECTM_PREFIX='\"${CMAKE_INSTALL_PREFIX}\"')
endif(${CMAKE_PROJECT_NAME} MATCHES ${PROJECT_NAME})

if (APPLE)
ADD_DEFINITIONS(-DRESOURCE_PREFIX='\"Resources\"')
else (APPLE)
ADD_DEFINITIONS(-DRESOURCE_PREFIX='\"share/projectM\"')
endif (APPLE)

FIND_PACKAGE(OpenGL)
FIND_PACKAGE(Qt4 REQUIRED)

pkg_search_module(JACK REQUIRED jack)

if (LIBPROJECTM_FOUND)
MESSAGE (STATUS "[projectM-jack] projectM detected.")
else(LIBPROJECTM_FOUND)
MESSAGE (FATAL_ERROR "projectM NOT detected. Please install the projectM module or build from the top level projectM source directory.")
endif(LIBPROJECTM_FOUND)

if (LIBPROJECTM-QT_FOUND)
MESSAGE (STATUS "[projectM-jack] projectM-qt detected.")
else(LIBPROJECTM-QT_FOUND)
MESSAGE (FATAL_ERROR "projectM-qt NOT detected. Please install the projectM-qt module or build from the top level projectM source directory. You can also disable QT_PROJECTM_JACK support and use the SDL port instead")
endif(LIBPROJECTM-QT_FOUND)

if (JACK_FOUND)
MESSAGE(STATUS "[projectM-jack] jack detected.")
else (JACK_FOUND)
MESSAGE( "JACK is NOT found. Please install jack from http://www.jackaudio.org.")
endif(JACK_FOUND)


set(projectM_jack_SRCS
  qprojectM-jack.cpp ConfigFile.h ConfigFile.cpp
)

set(projectM_jack_MOC_HDRS

)


# After this call, foo_MOC_SRCS = moc_Class1.cxx moc_Class2.cxx moc_Class3.cxx.
qt4_wrap_cpp(projectM_jack_MOC_SRCS ${projectM_MOC_HDRS})


ADD_DEFINITIONS(-DLINUX)
ADD_DEFINITIONS(${QT_DEFINITIONS})
ADD_DEFINITIONS(-DQT_NO_DEBUG)


if (${CMAKE_PROJECT_NAME} MATCHES "projectM-complete")
   set(PROJECTM_INCLUDE ${PROJECTM_ROOT_SOURCE_DIR}/libprojectM ${PROJECTM_ROOT_SOURCE_DIR}/projectM-qt)
   set(PROJECTM_LINK ${PROJECTM_ROOT_BINARY_DIR}/libprojectM ${PROJECTM_ROOT_BINARY_DIR}/projectM-qt)
elseif (${CMAKE_PROJECT_NAME} MATCHES ${PROJECT_NAME})
   set(PROJECTM_INCLUDE ${LIBPROJECTM_INCLUDEDIR}/libprojectM-qt ${LIBPROJECTM-QT_INCLUDEDIR}/libprojectM)
   set(PROJECTM_LINK ${LIBPROJECTM_LDFLAGS} ${LIBPROJECTM-QT_LDFLAGS})
# projectM-qt places itself in same location as (lib)projectM
# whether it should is a whole other issue
endif (${CMAKE_PROJECT_NAME} MATCHES "projectM-complete")


INCLUDE_DIRECTORIES(${PROJECTM_INCLUDE} ${JACK_INCLUDEDIR} ${SDL_INCLUDE_DIR} ${QT_INCLUDE_DIR} ${QT_QTGUI_INCLUDE_DIR} ${QT_QTOPENGL_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR})

LINK_DIRECTORIES(${PROJECTM_LINK})

if(COMMAND cmake_policy)
      cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

ADD_EXECUTABLE(projectM-jack ${projectM_jack_SRCS} ${projectM_jack_MOC_SRCS})

if (BUILD_PROJECTM_JACK_STATIC)
if (BUILD_PROJECTM_QT_STATIC)
SET(PACKAGED_LIBRARIES ${PROJECTM_ROOT_BINARY_DIR}/projectM-engine/libprojectM.a ${PROJECTM_ROOT_BINARY_DIR}/projectM-qt/libprojectM-qt.a)
else(BUILD_PROJECTM_QT_STATIC)
SET(PACKAGED_LIBRARIES ${PROJECTM_ROOT_BINARY_DIR}/projectM-engine/libprojectM.a projectM-qt)
endif(BUILD_PROJECTM_QT_STATIC)
else (BUILD_PROJECTM_JACK_STATIC)
SET(PACKAGED_LIBRARIES projectM-qt projectM)
endif (BUILD_PROJECTM_JACK_STATIC)

TARGET_LINK_LIBRARIES(projectM-jack ${PACKAGED_LIBRARIES} jack ${QT_QTGUI_LIBRARIES} ${QT_QTOPENGL_LIBRARIES} ${QT_QTCORE_LIBRARIES} ${QT_LIBRARIES} ${OPENGL_LIBRARIES} ${QT_QTXML_LIBRARIES})

INSTALL(TARGETS projectM-jack DESTINATION ${CMAKE_INSTALL_PREFIX}/bin )
install(FILES "projectM-jack.desktop" DESTINATION ${CMAKE_INSTALL_PREFIX}/share/applications)

else (QT_JACK_SUPPORT)
ADD_EXECUTABLE(projectM-jack projectM-jack.cpp sdltoprojectM.h video_init.cpp ConfigFile.h ConfigFile.cpp)

INCLUDE(FindPkgConfig.cmake)

FIND_PACKAGE(OpenGL)
FIND_PACKAGE(SDL)

if (${CMAKE_PROJECT_NAME} MATCHES ${PROJECT_NAME})
	pkg_search_module(LIBPROJECTM REQUIRED libprojectM)
else (${CMAKE_PROJECT_NAME} MATCHES ${PROJECT_NAME})
	set(LIBPROJECTM_FOUND true)
endif(${CMAKE_PROJECT_NAME} MATCHES ${PROJECT_NAME})

pkg_search_module(JACK REQUIRED jack)

if (JACK_FOUND)
MESSAGE(STATUS "[projectM-jack] jack detected.")
else (JACK_FOUND)
MESSAGE(FATAL_ERROR "JACK is NOT found. Please install jack from http://www.jackaudio.org.")
endif(JACK_FOUND)

if (LIBPROJECTM_FOUND)
MESSAGE (STATUS "[projectM-jack] projectM detected.")
else(LIBPROJECTM_FOUND)
MESSAGE (FATAL_ERROR "projectM NOT detected. Please install the projectM module or build from the top level projectM source directory.")
endif(LIBPROJECTM_FOUND)

if (${CMAKE_PROJECT_NAME} MATCHES "projectM-complete")
   set(PROJECTM_INCLUDE ${PROJECTM_ROOT_SOURCE_DIR}/projectM-engine)
   set(PROJECTM_LINK ${PROJECTM_ROOT_BINARY_DIR}/projectM-engine)
elseif (${CMAKE_PROJECT_NAME} MATCHES ${PROJECT_NAME})
   set(PROJECTM_INCLUDE ${LIBPROJECTM_INCLUDEDIR}/libprojectM)
   set(PROJECTM_LINK ${LIBPROJECTM_LDFLAGS})
endif (${CMAKE_PROJECT_NAME} MATCHES "projectM-complete")

INCLUDE_DIRECTORIES(${PROJECTM_INCLUDE} ${JACK_INCLUDEDIR} ${SDL_INCLUDE_DIR})
LINK_DIRECTORIES(${PROJECTM_LINK} ${JACK_LDFLAGS})

TARGET_LINK_LIBRARIES(projectM-jack projectM jack ${SDL_LIBRARY})

INSTALL(TARGETS projectM-jack DESTINATION ${CMAKE_INSTALL_PREFIX}/bin )
install(FILES "projectM-jack.desktop" DESTINATION ${CMAKE_INSTALL_PREFIX}/share/applications)
endif(QT_JACK_SUPPORT)

=== src/projectM-libvisual-alsa/CMakeLists.txt ===
PROJECT(projectM-libvisual-alsa)
cmake_minimum_required(VERSION 2.4.0)

ADD_EXECUTABLE(projectM-libvisual-alsa projectM-libvisual-alsa.c display.c glxdriver.c x11driver.c sdldriver.c lv_x11_key.c)

cmake_policy(SET CMP0005 OLD)

INCLUDE(FindPkgConfig.cmake)

FIND_PACKAGE(OpenGL)
FIND_PACKAGE(SDL)
FIND_PACKAGE(X11)
INCLUDE(cmake/CPack-projectM.cmake)

if (${CMAKE_PROJECT_NAME} MATCHES ${PROJECT_NAME})
	pkg_search_module(LIBPROJECTM REQUIRED libprojectM)
else (${CMAKE_PROJECT_NAME} MATCHES ${PROJECT_NAME})
	set(LIBPROJECTM_FOUND true)
endif(${CMAKE_PROJECT_NAME} MATCHES ${PROJECT_NAME})

if (LIBPROJECTM_FOUND)
MESSAGE (STATUS "[projectM-libvisual-alsa] projectM detected.")
else(LIBPROJECTM_FOUND)
MESSAGE (FATAL_ERROR "projectM NOT detected. Please install the projectM module or build from the top level projectM source directory.")
endif(LIBPROJECTM_FOUND)

pkg_search_module(LIBVISUAL REQUIRED libvisual-0.4)

if(LIBVISUAL_FOUND)
MESSAGE(STATUS "[projectM-libvisual] libvisual detected.")
else(LIBVISUAL_FOUND)
MESSAGE(FATAL_ERROR "libvisual 0.4 not found! Please visit http://libvisual.sf.net and download the module.")
endif(LIBVISUAL_FOUND)

ADD_DEFINITIONS(-DLINUX -DPROJECTM_PREFIX='\"${PROJECTM_PREFIX}\"')

INCLUDE_DIRECTORIES(${SDL_INCLUDE_DIR} ${LIBVISUAL_INCLUDEDIR} ${X11_INCLUDE_DIR})

LINK_DIRECTORIES(${LIBVISUAL_LDFLAGS})

TARGET_LINK_LIBRARIES(projectM-libvisual-alsa -lXxf86vm -L/usr/X11R6/lib ${OPENGL_LIBRARIES} ${LIBVISUAL_LIBRARIES} ${X11_LIBRARIES} ${SDL_LIBRARY} ${GTK_LIBRARIES})

INSTALL(TARGETS projectM-libvisual-alsa DESTINATION ${CMAKE_INSTALL_PREFIX}/bin )
install(FILES "projectM-libvisual-alsa.desktop" DESTINATION ${CMAKE_INSTALL_PREFIX}/share/applications)

=== debian/changelog ===
projectm (2.1.0+dfsg-4) unstable; urgency=medium

  * Acknowledge NMU
  * fix-gcc6-build.patch: Fix FTBFS with GCC 6 (Closes: #811831)
  * Stop building debug package: We have automatic dbgsym packages now
  * Bump standards version: No changes needed
  * Use secure Vcs-* URLs
  * Modernize gbp.conf

 -- Matthias Klumpp <mak@debian.org>  Thu, 28 Jul 2016 22:24:56 +0200

projectm (2.1.0+dfsg-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Use fonts-dejavu-core instead of ttf-dejavu-core (Closes: #733957)

 -- Adam Borowski <kilobyte@angband.pl>  Sat, 30 Apr 2016 04:19:39 +0200

projectm (2.1.0+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.

 -- Sebastian Ramacher <sramacher@debian.org>  Wed, 05 Aug 2015 00:25:42 +0200

projectm (2.1.0+dfsg-2) experimental; urgency=medium

  * Team upload.

  [ Matthias Klumpp ]
  * Fix debian/watch file
  * Use my Debian mail address
  * Bump standards version (no change needed)

  [ Sebastian Ramacher ]
  * Rename library packages for GCC 5 transition.
  * debian/copyright: Fix lintian warnings.

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 02 Aug 2015 18:47:32 +0200

projectm (2.1.0+dfsg-1) unstable; urgency=low

  * New upstream release: 2.1.0
    - Fixed several memory leaks (when projectM gets destroyed,
       or when a preset gets destroyed)
    - Resolved some parser errors and an embarrasing evaluation bug
       (in particular, 2^x does not equal x^2)
    - +/- keys support to edit the ratings
    - libvisual / gstreamer compatibility
    - Various cmake build fixes and improvements
    - Patches for better Linux distribution integration
  * Switch to compat-level 9
  * Update dfsg-free projectM generator script
  * Drop all patches: Applied upstream
  * Install libvisual-plugin into multiarch dir
  * Set font-settings as build-time parameters
  * Make debian/copyright DEP-5 compliant

 -- Matthias Klumpp <matthias@tenstral.net>  Mon, 21 May 2012 14:25:49 +0200

projectm (2.0.1+dfsg-12) unstable; urgency=low

  * Make parser handle cases like "1.0-1.0-2.0"
  * Fix wrong sqr and sigmoid functions
  * Unbind FBO when done (might fix some OGL errors)

 -- Matthias Klumpp <matthias@tenstral.net>  Sun, 01 Jan 2012 18:31:08 +0100

projectm (2.0.1+dfsg-11) unstable; urgency=low

  [ Reinhard Tartler ]
  * use Breaks: libprojectm-data instead Conflicts

  [ Matthias Klumpp ]
  * Fix FTBFS with recent PulseAudio versions (Closes: #646492)
  * Adjust path to projectM header (Closes: #642498)
  * Allow DM upload
  * Fix FTBFS on multiarch Debian config (files were placed wrong)

 -- Matthias Klumpp <matthias@tenstral.net>  Sun, 20 Nov 2011 21:14:58 +0100

projectm (2.0.1+dfsg-10) unstable; urgency=low

  * Use DejaVu font instead of Bistream-Vera (Closes: #630557)
  * Update my email-address
  * Update projectM-Qt dev package dependencies
  * Fix projectM linking (LP: #819025)
  * Rebuild for libglew1.5 -> libglew1.6 transition

 -- Matthias Klumpp <matthias@tenstral.net>  Mon, 01 Aug 2011 19:40:08 +0200

projectm (2.0.1+dfsg-9) unstable; urgency=low

  * Fix incorrect token parsing in presetfactory
    projectM-pulseaudio hangs whilst trying to parse
    the idle preset due to incorrect token parsing in
    libprojectm2 (Closes: #627616).
    Thanks to Adam Guthrie for the patch!
  * Adjusted VCS links

 -- Matthias Klumpp <matthias@nlinux.org>  Thu, 09 Jun 2011 13:38:29 +0200

projectm (2.0.1+dfsg-8) unstable; urgency=low

  * Team upload.
  * Add patch to fix FTBFS with GCC4.6 (Closes: #624898, LP: #771045).
  * Bump Standards.

 -- Alessio Treglia <alessio@debian.org>  Fri, 06 May 2011 14:24:11 +0200

projectm (2.0.1+dfsg-7) unstable; urgency=low

  [ Matthias Klumpp ]
  * Bump debhelper version dependency
  * Make more use of dh-auto commands
  * Patch projectM cmake script to find FreeType
  * Set LC_NUMERIC to "C" in libprojectM (LP: #737915)

  [ Alessio Treglia ]
  * Correct team's name.

  [ Reinhard Tartler ]
  * add myself to uploaders
  * normalize fields with wrap-and-sort(1)
  * apply best practices for dpkg source format 3.0 (quilt)

 -- Reinhard Tartler <siretart@tauware.de>  Wed, 23 Mar 2011 20:38:38 +0100

projectm (2.0.1+dfsg-6) experimental; urgency=low

  * Added some missing setter methods for Clementine (Closes: #600653)

 -- Matthias Klumpp <matthias@nlinux.org>  Fri, 19 Nov 2010 20:30:12 +0100

=== debian/control ===
Source: projectm
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: Matthias Klumpp <mak@debian.org>,
           Reinhard Tartler <siretart@tauware.de>
Vcs-Git: https://anonscm.debian.org/git/pkg-multimedia/projectm.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-multimedia/projectm.git
Build-Depends: cmake,
               debhelper (>= 9.0.0),
               g++ (>= 4:5.1.1-20),
               libfreetype6-dev,
               libftgl-dev,
               libgl1-mesa-dev,
               libglew-dev,
               libglu-dev,
               libice-dev,
               libjack-dev,
               libpulse-dev,
               libqt4-dev,
               libqt4-opengl-dev,
               libsdl1.2-dev,
               libvisual-0.4-dev,
               libx11-dev
Standards-Version: 3.9.8
Homepage: http://projectm.sf.net

Package: libprojectm2v5
Architecture: any
Section: libs
Depends: fonts-dejavu-core,
         projectm-data,
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: libprojectm2
Replaces: libprojectm-data (<< 2.0.1),
          libprojectm2
Description: Advanced Milkdrop-compatible music visualization library
 libprojectm is an iterative music visualization library which uses
 OpenGL for hardware acceleration. It is compatible with Milkdrop
 presets.
 .
 This package contains the library and essential data needed for
 the visualization library to work.

Package: libprojectm-dev
Section: libdevel
Architecture: any
Depends: libprojectm2v5 (= ${binary:Version}),
         ${misc:Depends}
Description: Advanced Milkdrop-compatible music visualization library - dev
 libprojectm is an iterative music visualization library which uses
 OpenGL for hardware acceleration. It is compatible with Milkdrop
 presets.
 .
 This package contains the development headers.

Package: projectm-data
Architecture: all
Section: libs
Replaces: libprojectm-data (<< 2.0.1)
Breaks: libprojectm-data (<< 2.0.1)
Depends: ${misc:Depends}
Description: Advanced Milkdrop-compatible music visualization library - data
 libprojectm is an iterative music visualization library which uses
 OpenGL for hardware acceleration. It is compatible with Milkdrop
 presets.
 .
 This package contains the presets which are distributed with
 projectM.

Package: libvisual-projectm
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: libvisual module for projectM
 projectM is an iterative music visualization library which uses
 OpenGL for hardware acceleration. It is compatible with Milkdrop
 presets.
 .
 This package contains a module for libvisual enabling support for
 projectM.

Package: libprojectm-qt1v5
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Breaks: libprojectm-qt1
Replaces: libprojectm-qt1
Description: projectM Qt4 bindings
 projectM is an iterative music visualization library which uses
 OpenGL for hardware acceleration. It is compatible with Milkdrop
 presets.
 .
 This package contains Qt4 interfaces to projectM.

Package: libprojectm-qt-dev
Section: libdevel
Architecture: any
Depends: libprojectm-qt1v5 (= ${binary:Version}),
         libqt4-opengl-dev,
         ${misc:Depends}
Description: projectM Qt4 (development files)
 projectM is an iterative music visualization library which uses
 OpenGL for hardware acceleration. It is compatible with Milkdrop
 presets.
 .
 This package contains the development files for the Qt4 bindings of projectM

Package: projectm-jack
Architecture: any
Depends: jackd,
         ${misc:Depends},
         ${shlibs:Depends}
Description: projectM JackAudio module
 projectM is an iterative music visualization library which uses
 OpenGL for hardware acceleration. It is compatible with Milkdrop
 presets.
 .
 This package contains an application to visualize JackAudio streams.

Package: projectm-pulseaudio
Architecture: any
Depends: pulseaudio,
         ${misc:Depends},
         ${shlibs:Depends}
Description: projectM PulseAudio module
 projectM is an iterative music visualization library which uses
 OpenGL for hardware acceleration. It is compatible with Milkdrop
 presets.
 .
 This package contains an application to visualize PulseAudio streams.

=== debian/watch ===
version=3

opts=dversionmangle=s/\+dfsg// \
http://sf.net/projectm/projectM-(\d+(?:\.\d+)+)-Source\.tar\.gz

## projectm 3.1.7

=== debian/changelog ===
projectm (3.1.7-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * projectm-data: Add Breaks+Replaces: libprojectm2 (Closes: #988171)

 -- Andreas Beckmann <anbe@debian.org>  Sun, 01 Aug 2021 21:42:23 +0200

projectm (3.1.7-1) unstable; urgency=medium

  * New upstream version 3.1.7
  * Update patchset
    + Provide keyboard controls in projectM-jack man page (Closes: #692582)
  * Remove README.md from new wrong path

 -- Dennis Braun <d_braun@kabelmail.de>  Sat, 01 Aug 2020 23:02:11 +0200

projectm (3.1.3-2) unstable; urgency=medium

  * Update Breaks and Replaces for projectm-data (Closes: #963726)
  * Add X-AppStream-Ignore=true to the desktop files
  * Remove unused ${shlibs:Depends} from libprojectm-dev
  * Add proper pthread linking

 -- Dennis Braun <d_braun@kabelmail.de>  Mon, 29 Jun 2020 19:15:01 +0200

projectm (3.1.3-1) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/copyright: Change Format URL to correct one
  * d/control: Set Vcs-* to salsa.debian.org

  [ Felipe Sateler ]
  * Change maintainer address to debian-multimedia@lists.debian.org

  [ Ondřej Nový ]
  * d/watch: Use https protocol

  [ Matt Beary ]
  * update link to upstream
  * update watch file to the new github location
  * correct font paths in build script

  [ Dennis Braun ]
  * New upstream version 3.1.3
    + Win and Mac modules are removed by upstream
  * Remove obsolete qt and libvisual packages
  * Remove obsolete debian files
  * Enable OpenGL ES support
    + Add projectm-sdl as package
  * Bump SO version
  * d/control:
    + Use dh-compat instead of d/compat and bump to 13
    + Update B-D and Depends
    + Bump S-V to 4.5.0
    + Add me as uploader
    + Set RRR: no
    + Set M-A: Foreign for projectm-data
    + Set M-A: Same for libprojectm3 & libprojectm-dev
  * Update d/copyright file
  * Update install files
  * Add d/not-installed
  * Add new patchset
  * Update d/rules
    + Add hardening
    + Fix installation
  * Add d/upstream/metadata
  * Update d/watch file

 -- Dennis Braun <d_braun@kabelmail.de>  Thu, 07 May 2020 23:01:38 +0200

=== debian/control ===
Source: projectm
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Matthias Klumpp <mak@debian.org>,
           Reinhard Tartler <siretart@tauware.de>,
           Dennis Braun <d_braun@kabelmail.de>
Vcs-Git: https://salsa.debian.org/multimedia-team/projectm.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/projectm
Build-Depends: debhelper-compat (= 13),
               libfreetype6-dev,
               libftgl-dev,
               libgl1-mesa-dev,
               libgles-dev,
               libglew-dev,
               libglm-dev,
               libglu-dev,
               libice-dev,
               libjack-dev,
               libpulse-dev,
               libqt5opengl5-dev,
               libsdl2-dev,
               libvisual-0.4-dev,
               libx11-dev,
               qtbase5-dev
Standards-Version: 4.5.0
Homepage: https://github.com/projectM-visualizer/projectm
Rules-Requires-Root: no

Package: libprojectm3
Architecture: any
Multi-Arch: same
Section: libs
Depends: ttf-bitstream-vera,
         projectm-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Advanced Milkdrop-compatible music visualization library
 libprojectm is an iterative music visualization library which uses
 OpenGL for hardware acceleration. It is compatible with Milkdrop
 presets.
 .
 This package contains the library and essential data needed for
 the visualization library to work.

Package: libprojectm-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libprojectm3 (= ${binary:Version}),
         ${misc:Depends}
Description: Advanced Milkdrop-compatible music visualization library - dev
 libprojectm is an iterative music visualization library which uses
 OpenGL for hardware acceleration. It is compatible with Milkdrop
 presets.
 .
 This package contains the development headers.

Package: projectm-data
Architecture: all
Multi-Arch: foreign
Section: libs
Depends: ${misc:Depends}
Breaks: libprojectm2v5 (<< 3.1.3-1), libprojectm2
Replaces: libprojectm2v5 (<< 3.1.3-1), libprojectm2
Description: Advanced Milkdrop-compatible music visualization library - data
 libprojectm is an iterative music visualization library which uses
 OpenGL for hardware acceleration. It is compatible with Milkdrop
 presets.
 .
 This package contains the presets which are distributed with
 projectM.

Package: projectm-jack
Architecture: any
Depends: jackd,
         ${misc:Depends},
         ${shlibs:Depends}
Description: projectM JackAudio module
 projectM is an iterative music visualization library which uses
 OpenGL for hardware acceleration. It is compatible with Milkdrop
 presets.
 .
 This package contains an application to visualize JackAudio streams.

Package: projectm-pulseaudio
Architecture: any
Depends: pulseaudio,
         ${misc:Depends},
         ${shlibs:Depends}
Description: projectM PulseAudio module
 projectM is an iterative music visualization library which uses
 OpenGL for hardware acceleration. It is compatible with Milkdrop
 presets.
 .
 This package contains an application to visualize PulseAudio streams.

Package: projectm-sdl
Architecture: any
Depends: projectm-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: projectM SDL module
 projectm is an iterative music visualization library which uses
 OpenGL for hardware acceleration. It is compatible with Milkdrop
 presets.
 .
 This package contains the SDL module which is distributed with
 projectM.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

CFLAGS:= -lpthread $(CFLAGS)
LDFLAGS:= -lpthread $(LDFLAGS)

%:
	dh $@
	
override_dh_auto_configure:
	dh_auto_configure -- --enable-gles
	
override_dh_auto_install:
	dh_auto_install
	# Clean installation
	rm $(CURDIR)/debian/tmp/usr/share/projectM/presets/*.so
	rm $(CURDIR)/debian/tmp/usr/share/projectM/presets/.*DS_Store
	rm $(CURDIR)/debian/tmp/usr/share/projectM/presets/tests/README.md
	find debian/tmp -name '*.a' -delete -or -name '*.la' -delete

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/projectM-?(\d\S*)\.tar\.gz/projectm-$1\.tar\.gz/ \
  https://github.com/projectM-visualizer/projectm/releases .*/projectM-(\d\S*)\.tar\.gz

## projectm 3.1.12

=== vendor/glm/CMakeLists.txt ===
file(GLOB ROOT_SOURCE *.cpp)
file(GLOB ROOT_INLINE *.inl)
file(GLOB ROOT_HEADER *.hpp)
file(GLOB ROOT_TEXT ../*.txt)
file(GLOB ROOT_MD ../*.md)
file(GLOB ROOT_NAT ../util/glm.natvis)

file(GLOB_RECURSE CORE_SOURCE ./detail/*.cpp)
file(GLOB_RECURSE CORE_INLINE ./detail/*.inl)
file(GLOB_RECURSE CORE_HEADER ./detail/*.hpp)

file(GLOB_RECURSE EXT_SOURCE ./ext/*.cpp)
file(GLOB_RECURSE EXT_INLINE ./ext/*.inl)
file(GLOB_RECURSE EXT_HEADER ./ext/*.hpp)

file(GLOB_RECURSE GTC_SOURCE ./gtc/*.cpp)
file(GLOB_RECURSE GTC_INLINE ./gtc/*.inl)
file(GLOB_RECURSE GTC_HEADER ./gtc/*.hpp)

file(GLOB_RECURSE GTX_SOURCE ./gtx/*.cpp)
file(GLOB_RECURSE GTX_INLINE ./gtx/*.inl)
file(GLOB_RECURSE GTX_HEADER ./gtx/*.hpp)

file(GLOB_RECURSE SIMD_SOURCE ./simd/*.cpp)
file(GLOB_RECURSE SIMD_INLINE ./simd/*.inl)
file(GLOB_RECURSE SIMD_HEADER ./simd/*.h)

source_group("Text Files" FILES ${ROOT_TEXT} ${ROOT_MD})
source_group("Core Files" FILES ${CORE_SOURCE})
source_group("Core Files" FILES ${CORE_INLINE})
source_group("Core Files" FILES ${CORE_HEADER})
source_group("EXT Files" FILES ${EXT_SOURCE})
source_group("EXT Files" FILES ${EXT_INLINE})
source_group("EXT Files" FILES ${EXT_HEADER})
source_group("GTC Files" FILES ${GTC_SOURCE})
source_group("GTC Files" FILES ${GTC_INLINE})
source_group("GTC Files" FILES ${GTC_HEADER})
source_group("GTX Files" FILES ${GTX_SOURCE})
source_group("GTX Files" FILES ${GTX_INLINE})
source_group("GTX Files" FILES ${GTX_HEADER})
source_group("SIMD Files" FILES ${SIMD_SOURCE})
source_group("SIMD Files" FILES ${SIMD_INLINE})
source_group("SIMD Files" FILES ${SIMD_HEADER})

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/..)

if(GLM_STATIC_LIBRARY_ENABLE OR GLM_DYNAMIC_LIBRARY_ENABLE)
	if(GLM_STATIC_LIBRARY_ENABLE)
		add_library(glm_static STATIC ${ROOT_TEXT} ${ROOT_MD} ${ROOT_NAT}
			${ROOT_SOURCE}    ${ROOT_INLINE}    ${ROOT_HEADER}
			${CORE_SOURCE}    ${CORE_INLINE}    ${CORE_HEADER}
			${EXT_SOURCE}     ${EXT_INLINE}     ${EXT_HEADER}
			${GTC_SOURCE}     ${GTC_INLINE}     ${GTC_HEADER}
			${GTX_SOURCE}     ${GTX_INLINE}     ${GTX_HEADER}
			${SIMD_SOURCE}    ${SIMD_INLINE}    ${SIMD_HEADER})
	endif(GLM_STATIC_LIBRARY_ENABLE)

	if(GLM_DYNAMIC_LIBRARY_ENABLE)
		add_library(glm_shared SHARED ${ROOT_TEXT} ${ROOT_MD} ${ROOT_NAT}
			${ROOT_SOURCE}    ${ROOT_INLINE}    ${ROOT_HEADER}
			${CORE_SOURCE}    ${CORE_INLINE}    ${CORE_HEADER}
			${EXT_SOURCE}     ${EXT_INLINE}     ${EXT_HEADER}
			${GTC_SOURCE}     ${GTC_INLINE}     ${GTC_HEADER}
			${GTX_SOURCE}     ${GTX_INLINE}     ${GTX_HEADER}
			${SIMD_SOURCE}    ${SIMD_INLINE}    ${SIMD_HEADER})
	endif(GLM_DYNAMIC_LIBRARY_ENABLE)

else(GLM_STATIC_LIBRARY_ENABLE OR GLM_DYNAMIC_LIBRARY_ENABLE)
	add_executable(glm_dummy ${ROOT_TEXT} ${ROOT_MD} ${ROOT_NAT}
		${ROOT_SOURCE}    ${ROOT_INLINE}    ${ROOT_HEADER}
		${CORE_SOURCE}    ${CORE_INLINE}    ${CORE_HEADER}
		${EXT_SOURCE}     ${EXT_INLINE}     ${EXT_HEADER}
		${GTC_SOURCE}     ${GTC_INLINE}     ${GTC_HEADER}
		${GTX_SOURCE}     ${GTX_INLINE}     ${GTX_HEADER}
		${SIMD_SOURCE}    ${SIMD_INLINE}    ${SIMD_HEADER})

endif(GLM_STATIC_LIBRARY_ENABLE OR GLM_DYNAMIC_LIBRARY_ENABLE)

=== debian/changelog ===
projectm (3.1.12-4) unstable; urgency=medium

  [ Dylan Aïssi ]
  * Add pipewire-pulse as an alternative to pulseaudio

  [ Dennis Braun ]
  * Change my email address
  * Bump my d/copyright year
  * Clean build files (Closes: #1046094)
  * Build-Depends: libgl1-mesa-dev => libgl-dev
  * Add projectm-data as a depedency of projectm-jack (Closes: #1058583)

 -- Dennis Braun <snd@debian.org>  Wed, 10 Jan 2024 20:25:46 +0100

projectm (3.1.12-3) unstable; urgency=medium

  * Fix arm builds by adding the gl header to qprojectmwidget.hpp
  * Fix cross compiling. Thanks a lot to Helmut Grohne (Closes: #1022752)
  * Reformat all patches with gbp pq
  * Prefer libjack-dev over libjack-jackd2-dev
  * Apply wrap-and-sort -ast
  * d/copyright: Bump my entry
  * Add d/source/lintian-overrides
  * d/watch: Fix regex for github
  * Add salsa ci config

 -- Dennis Braun <d_braun@kabelmail.de>  Mon, 31 Oct 2022 13:35:02 +0100

projectm (3.1.12-2) unstable; urgency=medium

  * Bump Standards Version to 4.6.1
  * Switch projectm3 dependency from ttf-bitstream-vera to fonts-dejavu-core
    (Closes: #998268)
    + Update font patch: Use fonts-dejavu-core instead of ttf-bitstream-vera
  * Make projectm-pulseaudio depend on projectm-data (Closes: #997665)
  * Add libjack-jackd2-dev as B-D and libjack-dev as optional

 -- Dennis Braun <d_braun@kabelmail.de>  Mon, 06 Jun 2022 11:51:59 +0200

projectm (3.1.12-1) unstable; urgency=medium

  [ Dennis Braun ]
  * New upstream version 3.1.12
  * Refresh patchset, drop patches applied by upstream
  * Bump S-V to 4.5.1
  * Add d/source/lintian-overrides
  * Revert 'Remove README.md from new wrong path'

  [ Sebastian Ramacher ]
  * debian/control: Remove Breaks+Replaces post-bullseye

 -- Dennis Braun <d_braun@kabelmail.de>  Sun, 03 Oct 2021 22:23:27 +0200

=== debian/control ===
Source: projectm
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Matthias Klumpp <mak@debian.org>,
 Reinhard Tartler <siretart@tauware.de>,
 Dennis Braun <snd@debian.org>,
Vcs-Git: https://salsa.debian.org/multimedia-team/projectm.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/projectm
Build-Depends:
 autoconf-archive (>= 20220903-2),
 debhelper-compat (= 13),
 libfreetype6-dev,
 libftgl-dev,
 libgl-dev,
 libgles-dev,
 libglew-dev,
 libglm-dev,
 libglu-dev,
 libice-dev,
 libjack-dev | libjack-jackd2-dev,
 libpulse-dev,
 libqt5opengl5-dev,
 libsdl2-dev,
 libvisual-0.4-dev,
 libx11-dev,
 qtbase5-dev,
Standards-Version: 4.6.1
Homepage: https://github.com/projectM-visualizer/projectm
Rules-Requires-Root: no

Package: libprojectm3
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 fonts-dejavu-core,
 projectm-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Advanced Milkdrop-compatible music visualization library
 libprojectm is an iterative music visualization library which uses
 OpenGL for hardware acceleration. It is compatible with Milkdrop
 presets.
 .
 This package contains the library and essential data needed for
 the visualization library to work.

Package: libprojectm-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libprojectm3 (= ${binary:Version}),
 ${misc:Depends},
Description: Advanced Milkdrop-compatible music visualization library - dev
 libprojectm is an iterative music visualization library which uses
 OpenGL for hardware acceleration. It is compatible with Milkdrop
 presets.
 .
 This package contains the development headers.

Package: projectm-data
Architecture: all
Multi-Arch: foreign
Section: libs
Depends:
 ${misc:Depends},
Description: Advanced Milkdrop-compatible music visualization library - data
 libprojectm is an iterative music visualization library which uses
 OpenGL for hardware acceleration. It is compatible with Milkdrop
 presets.
 .
 This package contains the presets which are distributed with
 projectM.

Package: projectm-jack
Architecture: any
Depends:
 jackd,
 projectm-data,
 ${misc:Depends},
 ${shlibs:Depends},
Description: projectM JackAudio module
 projectM is an iterative music visualization library which uses
 OpenGL for hardware acceleration. It is compatible with Milkdrop
 presets.
 .
 This package contains an application to visualize JackAudio streams.

Package: projectm-pulseaudio
Architecture: any
Depends:
 projectm-data,
 pulseaudio | pipewire-pulse,
 ${misc:Depends},
 ${shlibs:Depends},
Description: projectM PulseAudio module
 projectM is an iterative music visualization library which uses
 OpenGL for hardware acceleration. It is compatible with Milkdrop
 presets.
 .
 This package contains an application to visualize PulseAudio streams.

Package: projectm-sdl
Architecture: any
Depends:
 projectm-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: projectM SDL module
 projectm is an iterative music visualization library which uses
 OpenGL for hardware acceleration. It is compatible with Milkdrop
 presets.
 .
 This package contains the SDL module which is distributed with
 projectM.

=== debian/rules ===
--- 
+++ 
@@ -8,6 +8,10 @@
 %:
 	dh $@
 	
+execute_before_dh_autoreconf:
+	# Copy the fixed ax_have_qt.m4 file. See #965273
+	cp -f /usr/share/aclocal/ax_have_qt.m4 m4/autoconf-archive/ax_have_qt.m4
+
 override_dh_auto_configure:
 	dh_auto_configure -- --enable-gles
 	
@@ -16,5 +20,4 @@
 	# Clean installation
 	rm $(CURDIR)/debian/tmp/usr/share/projectM/presets/*.so
 	rm $(CURDIR)/debian/tmp/usr/share/projectM/presets/.*DS_Store
-	rm $(CURDIR)/debian/tmp/usr/share/projectM/presets/tests/README.md
 	find debian/tmp -name '*.a' -delete -or -name '*.la' -delete

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/projectM-?(\d\S*)\.tar\.gz/projectm-$1\.tar\.gz/ \
  https://github.com/projectM-visualizer/projectm/tags .*/releases/tag/v?@ANY_VERSION@
